# Generated by the gRPC Python protocol compiler plugin. DO NOT EDIT!
"""Client and server classes corresponding to protobuf-defined services."""
import grpc
import warnings

import service_pb2 as service__pb2

GRPC_GENERATED_VERSION = '1.70.0'
GRPC_VERSION = grpc.__version__
_version_not_supported = False

try:
    from grpc._utilities import first_version_is_lower
    _version_not_supported = first_version_is_lower(GRPC_VERSION, GRPC_GENERATED_VERSION)
except ImportError:
    _version_not_supported = True

if _version_not_supported:
    raise RuntimeError(
        f'The grpc package installed is at version {GRPC_VERSION},'
        + f' but the generated code in service_pb2_grpc.py depends on'
        + f' grpcio>={GRPC_GENERATED_VERSION}.'
        + f' Please upgrade your grpc module to grpcio>={GRPC_GENERATED_VERSION}'
        + f' or downgrade your generated code using grpcio-tools<={GRPC_VERSION}.'
    )


class OrcaCoreStub(object):
    """OrcaCore is the central orchestration service that:
    - Manages the lifecycle of processing windows
    - Coordinates algorithm execution across distributed processors
    - Tracks DAG dependencies and execution state
    - Routes results between dependent algorithms
    """

    def __init__(self, channel):
        """Constructor.

        Args:
            channel: A grpc.Channel.
        """
        self.RegisterProcessor = channel.unary_unary(
                '/OrcaCore/RegisterProcessor',
                request_serializer=service__pb2.ProcessorRegistration.SerializeToString,
                response_deserializer=service__pb2.Status.FromString,
                _registered_method=True)
        self.EmitWindow = channel.unary_unary(
                '/OrcaCore/EmitWindow',
                request_serializer=service__pb2.Window.SerializeToString,
                response_deserializer=service__pb2.WindowEmitStatus.FromString,
                _registered_method=True)


class OrcaCoreServicer(object):
    """OrcaCore is the central orchestration service that:
    - Manages the lifecycle of processing windows
    - Coordinates algorithm execution across distributed processors
    - Tracks DAG dependencies and execution state
    - Routes results between dependent algorithms
    """

    def RegisterProcessor(self, request, context):
        """Register a processor node and its supported algorithms
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def EmitWindow(self, request, context):
        """Submit a window for processing
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')


def add_OrcaCoreServicer_to_server(servicer, server):
    rpc_method_handlers = {
            'RegisterProcessor': grpc.unary_unary_rpc_method_handler(
                    servicer.RegisterProcessor,
                    request_deserializer=service__pb2.ProcessorRegistration.FromString,
                    response_serializer=service__pb2.Status.SerializeToString,
            ),
            'EmitWindow': grpc.unary_unary_rpc_method_handler(
                    servicer.EmitWindow,
                    request_deserializer=service__pb2.Window.FromString,
                    response_serializer=service__pb2.WindowEmitStatus.SerializeToString,
            ),
    }
    generic_handler = grpc.method_handlers_generic_handler(
            'OrcaCore', rpc_method_handlers)
    server.add_generic_rpc_handlers((generic_handler,))
    server.add_registered_method_handlers('OrcaCore', rpc_method_handlers)


 # This class is part of an EXPERIMENTAL API.
class OrcaCore(object):
    """OrcaCore is the central orchestration service that:
    - Manages the lifecycle of processing windows
    - Coordinates algorithm execution across distributed processors
    - Tracks DAG dependencies and execution state
    - Routes results between dependent algorithms
    """

    @staticmethod
    def RegisterProcessor(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/OrcaCore/RegisterProcessor',
            service__pb2.ProcessorRegistration.SerializeToString,
            service__pb2.Status.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def EmitWindow(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/OrcaCore/EmitWindow',
            service__pb2.Window.SerializeToString,
            service__pb2.WindowEmitStatus.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)


class OrcaProcessorStub(object):
    """OrcaProcessor defines the interface that each processing node must implement.
    Processors are language-agnostic services that:
    - Execute individual algorithms
    - Handle their own internal state
    - Report results back to the orchestrator
    Orca will schedule processors asynchronously as per the DAG
    """

    def __init__(self, channel):
        """Constructor.

        Args:
            channel: A grpc.Channel.
        """
        self.ExecuteDagPart = channel.unary_stream(
                '/OrcaProcessor/ExecuteDagPart',
                request_serializer=service__pb2.ExecutionRequest.SerializeToString,
                response_deserializer=service__pb2.ExecutionResult.FromString,
                _registered_method=True)
        self.HealthCheck = channel.unary_unary(
                '/OrcaProcessor/HealthCheck',
                request_serializer=service__pb2.HealthCheckRequest.SerializeToString,
                response_deserializer=service__pb2.HealthCheckResponse.FromString,
                _registered_method=True)


class OrcaProcessorServicer(object):
    """OrcaProcessor defines the interface that each processing node must implement.
    Processors are language-agnostic services that:
    - Execute individual algorithms
    - Handle their own internal state
    - Report results back to the orchestrator
    Orca will schedule processors asynchronously as per the DAG
    """

    def ExecuteDagPart(self, request, context):
        """Execute part of a DAG with streaming results
        Server streams back execution results as they become available
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def HealthCheck(self, request, context):
        """Check health/status of processor. i.e. a heartbeat
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')


def add_OrcaProcessorServicer_to_server(servicer, server):
    rpc_method_handlers = {
            'ExecuteDagPart': grpc.unary_stream_rpc_method_handler(
                    servicer.ExecuteDagPart,
                    request_deserializer=service__pb2.ExecutionRequest.FromString,
                    response_serializer=service__pb2.ExecutionResult.SerializeToString,
            ),
            'HealthCheck': grpc.unary_unary_rpc_method_handler(
                    servicer.HealthCheck,
                    request_deserializer=service__pb2.HealthCheckRequest.FromString,
                    response_serializer=service__pb2.HealthCheckResponse.SerializeToString,
            ),
    }
    generic_handler = grpc.method_handlers_generic_handler(
            'OrcaProcessor', rpc_method_handlers)
    server.add_generic_rpc_handlers((generic_handler,))
    server.add_registered_method_handlers('OrcaProcessor', rpc_method_handlers)


 # This class is part of an EXPERIMENTAL API.
class OrcaProcessor(object):
    """OrcaProcessor defines the interface that each processing node must implement.
    Processors are language-agnostic services that:
    - Execute individual algorithms
    - Handle their own internal state
    - Report results back to the orchestrator
    Orca will schedule processors asynchronously as per the DAG
    """

    @staticmethod
    def ExecuteDagPart(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_stream(
            request,
            target,
            '/OrcaProcessor/ExecuteDagPart',
            service__pb2.ExecutionRequest.SerializeToString,
            service__pb2.ExecutionResult.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def HealthCheck(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_unary(
            request,
            target,
            '/OrcaProcessor/HealthCheck',
            service__pb2.HealthCheckRequest.SerializeToString,
            service__pb2.HealthCheckResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)
